#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "basic_io.h"

// leitura bloco a bloco em ordem aleatória

int main(int argc, char ** argv){

	int i, j, tmp;
	int * ids;
	long sum_of_block_ids;
	File * in;
	unsigned char * buffer;
	unsigned char * record_pointer;

	in = open_for_read(argv[1]);
	buffer = alloc_alligned_buffer(BLOCK_SIZE * MULTI_FACTOR);
	
	// array de ids	
	ids = (int *) malloc ((N_BLOCKS / MULTI_FACTOR) * sizeof(int));

	// iniciando array de ids
	for(i = 0; i < N_BLOCKS / MULTI_FACTOR; i++) ids[i] = i;

	// embaralhando array de ids
	for(i = 0; i < N_BLOCKS / MULTI_FACTOR; i++){

		j = random() % (N_BLOCKS / MULTI_FACTOR);

		tmp = ids[i];
		ids[i] = ids[j];
		ids[j] = tmp;
	}
	
	sum_of_block_ids = 0;

	for(i = 0; i < N_BLOCKS / MULTI_FACTOR; i++){

		seek(in, ids[i] * BLOCK_SIZE * MULTI_FACTOR);

		if(read_bytes(in, buffer, BLOCK_SIZE * MULTI_FACTOR) != BLOCK_SIZE * MULTI_FACTOR){

			printf("erro na leitura!\n");
			return 1;
		}

		// read all records inside block!

		for(j = 0; j < RECORDS_PER_BLOCK * MULTI_FACTOR; j++){

			record_pointer = buffer + (j * RECORD_SIZE);
			sum_of_block_ids += ((int *) record_pointer)[0];
		}
	}

	close_file(in);

	printf("soma = %ld\n", sum_of_block_ids);

	return 0;
}
